// TsDescrambler.h: CTsDescrambler NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(_TSDESCRAMBLER_H_)
#define _TSDESCRAMBLER_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <vector>
#include "IMediaDecoder.h"
#include "TsStream.h"
#include "TsTable.h"
#include "BcasCard.h"
#include "Multi2Decoder.h"
#include "../Common/Buffer.h"

using std::vector;


/////////////////////////////////////////////////////////////////////////////
// MULTI2XNu(ECMɂyC[h̃XNu)
/////////////////////////////////////////////////////////////////////////////
// Input	#0	: CTsPacket		ÍTSpPbg
// Output	#0	: CTsPacket		TSpPbg
/////////////////////////////////////////////////////////////////////////////

class CTsDescrambler : public IMediaDecoder  
{
public:
	CTsDescrambler();
	virtual ~CTsDescrambler();

// IMediaDecoder
	virtual void Reset(void);

	virtual const DWORD GetInputNum(void) const;
	virtual const DWORD GetOutputNum(void) const;

	virtual const bool InputMedia(CMediaData *pMediaData, const DWORD dwInputIndex = 0);
	virtual const bool InputMediaBuffer(CTsPacket *pTsPacket);
// CDeScrambler
	const bool OpenBcasCard(DWORD *pErrorCode = NULL);
	void CloseBcasCard(void);
	const bool GetBcasCardID(BYTE *pCardID);

	const DWORD GetInputPacketCount(void) const;
	const DWORD GetOutputPacketCount(void) const;

#define CACHE_MAX (1024*1024)
#define B25_WAIT_LIMIT (1024*1020)
	static DWORD WINAPI RecvThread(LPVOID param);
	HANDLE	m_hRecvThread;
	BOOL	m_bEnd;
	int		m_nRead;
	int		m_nWrite;
	int		m_nCount;
	int		m_nMaxCount;
	CTsPacket* m_PacketCache[CACHE_MAX];
	CRITICAL_SECTION cs;

protected:
	const bool ProcPatPacket(const CTsPacket *pTsPacket);
	const bool ProcPmtPacket(const CTsPacket *pTsPacket);
	const bool ProcEcmPacket(const CTsPacket *pTsPacket);

	void OnPmtUpdate(const CPmtTable &PmtTable);
	CMulti2Decoder * GetDecoderByPID(const WORD wPID);
	const bool DescramblePacket(CTsPacket *pTsPacket);

	static void CALLBACK OnEcmSection(const CPsiSection *pSection, const PVOID pParam);

	struct TAG_PMTSET
	{
		WORD wPmtPID;
		CPmtTable PmtTable;
	};

	struct TAG_ECMSET
	{
		WORD wEcmPID;
		CPsiSectionParser EcmSectionParser;
		CPsiSection LastEcmSection;
		CMulti2Decoder Decoder;
	};

	CPatTable m_PatTable;
	vector<TAG_PMTSET> m_PmtList;
	vector<TAG_ECMSET> m_EcmList;

	WORD m_awEcmPidMap[0x2000];
	
	CBcasCard m_BcasCard;

	WORD m_wEcmSetIndex;

	DWORD m_dwInputPacketCount;
	DWORD m_dwOutputPacketCount;

	BOOL m_bReOpen;
};

#endif // !defined(_TSDESCRAMBLER_H_)
