// TsDescriptor.h: Lqqbp[NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "TsDescriptor.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


/////////////////////////////////////////////////////////////////////////////
// Lqq̊NX
/////////////////////////////////////////////////////////////////////////////

CBaseDesc::CBaseDesc()
{
	Reset();
}

CBaseDesc::CBaseDesc(const CBaseDesc &Operand)
{
	// Rs[RXgN^
	*this = Operand;
}

CBaseDesc & CBaseDesc::operator = (const CBaseDesc &Operand)
{
	// Zq
	m_byDescTag = Operand.m_byDescTag;
	m_byDescLen = Operand.m_byDescLen;
	m_bIsValid = Operand.m_bIsValid;

	return *this;
}

const bool CBaseDesc::IsValid(void) const
{
	// f[^L(͍)ǂԂ
	return m_bIsValid;
}

const BYTE CBaseDesc::GetTag(void) const
{
	// Lqq^OԂ
	return m_byDescTag;
}

const BYTE CBaseDesc::GetLen(void) const
{
	// LqqԂ
	return m_byDescLen;
}

void CBaseDesc::Reset(void)
{
	// ԂNA
	m_byDescTag = 0x00;
	m_byDescLen = 0;
	m_bIsValid = false;
}


/////////////////////////////////////////////////////////////////////////////
// [0x09] Conditional Access LqqۉNX
/////////////////////////////////////////////////////////////////////////////

CCaMethodDesc::CCaMethodDesc()
	: CBaseDesc()
{
	Reset();
}

CCaMethodDesc::CCaMethodDesc(const CCaMethodDesc &Operand)
{
	*this = Operand;
}

CCaMethodDesc & CCaMethodDesc::operator = (const CCaMethodDesc &Operand)
{
	CBaseDesc::operator = (Operand);

	m_wCaMethodID = Operand.m_wCaMethodID;
	m_wCaPID = Operand.m_wCaPID;
	m_PrivateData = Operand.m_PrivateData;

	return *this;
}

const bool CCaMethodDesc::ParseDesc(const BYTE *pHexData, const BYTE byDataLength)
{
	Reset();

	// tH[}bg`FbN
	if(!pHexData)return false;										// f[^
	else if(byDataLength < (pHexData[1] + 2))return false;			// f[^Lqq̃TCY
	else if(pHexData[0] != 0x09)return false;						// ^Os
	else if(pHexData[1] < 4)return false;							// CA\bhLqq̍ŏTCY4
	else if((pHexData[4] & 0xE0) != 0xE0)return false;				// Œrbgs

	// Lqq
	m_byDescTag = pHexData[0];										// +0	Description Tag
	m_byDescLen = pHexData[1];										// +1	Description Length
	m_wCaMethodID = (WORD)pHexData[2] << 8 | (WORD)pHexData[3];		// +2,3	Conditional Access Method ID
	m_wCaPID = (WORD)(pHexData[4] & 0x1F) << 8 | (WORD)pHexData[5];	// +4,5	Conditional Access PID
	m_PrivateData.SetData(&pHexData[6], m_byDescLen - 4);			// +6-	Private Data

	return (m_bIsValid = true);
}

void CCaMethodDesc::Reset(void)
{
	CBaseDesc::Reset();

	m_wCaMethodID = 0x0000;			// Conditional Access Method ID
	m_wCaPID = 0xFFFF;				// Conditional Access PID
}

const WORD CCaMethodDesc::GetCaMethodID(void) const
{
	// Conditional Access Method ID Ԃ
	return m_wCaMethodID;
}

const WORD CCaMethodDesc::GetCaPID(void) const
{
	// Conditional Access PID
	return m_wCaPID;
}

const CMediaData * CCaMethodDesc::GetPrivateData(void) const
{
	// Private Data Ԃ
	return &m_PrivateData;
}


/////////////////////////////////////////////////////////////////////////////
// [0x52] Stream Identifier LqqۉNX
/////////////////////////////////////////////////////////////////////////////

CStreamIdDesc::CStreamIdDesc()
	: CBaseDesc()
{
	Reset();
}

CStreamIdDesc::CStreamIdDesc(const CStreamIdDesc &Operand)
{
	*this = Operand;
}

CStreamIdDesc & CStreamIdDesc::operator = (const CStreamIdDesc &Operand)
{
	CBaseDesc::operator = (Operand);

	m_byComponentTag = Operand.m_byComponentTag;

	return *this;
}

const bool CStreamIdDesc::ParseDesc(const BYTE *pHexData, const BYTE byDataLength)
{
	Reset();

	// tH[}bg`FbN
	if(!pHexData)return false;					// f[^
	else if(byDataLength < 3)return false;		// f[^Lqq̃TCY
	else if(pHexData[0] != 0x52)return false;	// ^Os
	else if(pHexData[1] != 1)return false;		// Xg[IDLqq̃TCY͏1

	// Lqq
	m_byDescTag = pHexData[0];					// +0	Description Tag
	m_byDescLen = pHexData[1];					// +1	Description Length
	m_byComponentTag = pHexData[2];				// +2,3	Conditional Access Method ID

	return (m_bIsValid = true);
}

void CStreamIdDesc::Reset(void)
{
	CBaseDesc::Reset();

	m_byComponentTag = 0x00;	// Component Tag
}

const BYTE CStreamIdDesc::GetComponentTag(void) const
{
	// Component Tag Ԃ
	return m_byComponentTag;
}




